---
title: Content Index API
slug: Web/API/Content_Index_API
tags:
  - API
  - Content
  - Content Index API
  - Indexing
  - Landing
  - PWA
  - content indexing
---
<div>{{draft}}{{DefaultAPISidebar("Content Index API")}}</div>

<p class="summary">The Content Index API allows developers to register their offline enabled content with the browser.</p>

<h2 id="Concepts_and_Usage">Concepts and Usage</h2>

<p>As it stands, offline web content is not easily discoverable by users. Content indexing allows developers to tell the browser about their specific offline content. This allows users to discover and view what is available, whilst giving developers the ability to add and manage this content. Examples could be a news website prefetching the latest articles in the background, or a content streaming app registering downloaded content.</p>

<p>The Content Index API is an extension to <a href="/en-US/docs/Web/API/Service_Worker_API">service workers</a>, which allows developers to add URLs and metadata of already cached pages, under the scope of the current service worker. The browser can then use these entries to display offline reading to a user. As a developer you can also display these entries within your application.</p>

<p>Indexed entries do not automatically expire. It's good practice to present an interface for clearing out entries, or periodically remove older entries.</p>

<div class="note">
  <p>The API supports indexing URLs corresponding to HTML documents. A URL for a cached media file, for example, can't be indexed directly. Instead, you need to provide a URL for a page that displays media, and which works offline.</p>
</div>

<h2 id="Interfaces">Interfaces</h2>

<dl>
  <dt>{{domxref("ContentIndex")}}</dt>
  <dd>The <strong><code>ContentIndex</code></strong> interface provides functionality to register content available offline.</dd>

  <dt>{{domxref("ContentIndexEvent")}}</dt>
  <dd>The <strong><code>ContentIndexEvent</code></strong> interface of the {{domxref('Content Index API')}} defines the object used to represent the {{Event('contentdelete')}} event.</dd>

</dl>

<h2 id="Service_worker_additions">Service worker additions</h2>

<p>The following additions to the {{domxref('ServiceWorker')}} have been specified in the Content Index API spec to provide an entry point for using content indexing.</p>

<dl>
  <dt>{{domxref("ServiceWorkerRegistration.index")}} {{readonlyinline}}</dt>
  <dd>Returns a reference to the {{domxref("ContentIndex")}} interface for indexing cached pages.</dd>

  <dt>{{domxref("ServiceWorkerGlobalScope.oncontentdelete")}}</dt>
  <dd>An event handler fired whenever a {{Event("contentdelete")}} event occurs. This happens when content is removed by the user agent.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>All the following examples assume a service worker has been registered. For more information see the <a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API</a>.</p>

<h3 id="Feature_Detection_and_Interface_Access">Feature Detection and Interface Access</h3>

<p>Here we get a reference to the {{domxref('ServiceWorkerRegistration')}}, then check for the <code>index</code> property, which gives us access to the content index interface.</p>

<pre class="brush: js notranslate">// reference registration
const registration = await navigator.serviceWorker.ready;

// feature detection
if ('index' in registration) {

  // Content Index API functionality
  const contentIndex = registration.index;

}
</pre>

<h3 id="Adding_to_the_Content_Index">Adding to the Content Index</h3>

<p>Here we're declaring an item in the correct format and creating an asynchronous function which uses the {{domxref('ContentIndex.add','add()')}} method to register it with the {{domxref('Content Index API','content index')}}.</p>

<pre class="brush: js notranslate">// our content
const item = {
  id: 'post-1',
  url: '/posts/amet.html',
  title: 'Amet consectetur adipisicing',
  description: 'Repellat et quia iste possimus ducimus aliquid a aut eaque nostrum.',
  icons: [{
    src: '/media/dark.png',
    sizes: '128x128',
    type: 'image/png',
  }],
  category: 'article'
};

// our asynchronous function to add indexed content
async function registerContent(data) {
  const registration = await navigator.serviceWorker.ready;

  // feature detect Content Index
	if (!registration.index) {
		return;
	}

  // register content
  try {
		await registration.index.add(data);
  } catch (e) {
    console.log('Failed to register content: ', e.message);
  }
}
</pre>

<h3 id="Retrieving_Items_Within_The_Current_Index">Retrieving Items Within The Current Index</h3>

<p>The below example shows an asynchronous function that retrieves items within the {{domxref('Content Index API','content index')}} and iterates over each entry, building a list for the interface.</p>

<pre class="brush: js notranslate">async function createReadingList() {
  // access our service worker registration
  const registration = await navigator.serviceWorker.ready;

  // get our index entries
  const entries = await registration.index.getAll();

  // create a containing element
  const readingListElem = document.createElement('div');

  // test for entries
  if (!Array.length) {

    // if there are no entries, display a message
    const message = document.createElement('p');
    message.innerText = 'You currently have no articles saved for offline reading.'

    readingListElem.append(message);

  } else {

    // if entries are present, display in a list of links to the content
    const listElem = document.createElement('ul');

    for (const entry of entries) {
      const listItem = document.createElement('li');

      const anchorElem = document.createElement('a');
      anchorElem.innerText = entry.title;
      anchorElem.setAttribute('href', entry.url);

      listElem.append(listItem);

    }

    readingListElem.append(listElem);
  }

}
</pre>

<h3 id="Unregistering_Indexed_Content">Unregistering Indexed Content</h3>

<p>Below is an asynchronous function, that removes an item from the {{domxref('Content Index API','content index')}}.</p>

<pre class="brush: js notranslate">async function unregisterContent(article) {

  // reference registration
  const registration = await navigator.serviceWorker.ready;

  // feature detect Content Index
  if (!registration.index)
    return;

  // unregister content from index
  await registration.index.delete(article.id);
}
</pre>

<p>All the above methods are available within the scope of the {{domxref('ServiceWorker','service worker')}}. They are accessible from the {{domxref('WorkerGlobalScope.self')}} property:</p>

<pre class="brush: js notranslate">// service worker script

self.registration.index.add(item);

self.registration.index.delete(item.id);

const contentIndexItems = self.registration.index.getAll();
</pre>

<h3 id="contentdelete_event">contentdelete event</h3>

<p>When an item is removed from the user agent interface, a <code>contentdelete</code> event is received by the service worker.</p>

<pre class="brush: js notranslate">self.addEventListener('contentdelete', (event) =&gt; {
  console.log(event.id);

  // logs content index id, which can then be used to determine what content to delete from your cache

});
</pre>

<p>The {{Event('contentdelete')}} event is only fired when the deletion happens due to interaction with the browser's built-in user interface. It is not fired when the {{domxref('ContentIndex.delete')}} method is called.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Content Index API')}}</td>
   <td>{{Spec2('Content Index API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ContentIndex")}}</p>

<h2 id="See_also">See also:</h2>

<ul>
  <li><a href="https://web.dev/content-indexing-api/">An introductory article on the Content Index API</a></li>
  <li><a href="https://contentindex.dev/">An app which uses the Content Index API to list and remove 'save for later' content</a></li>
  <li><a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API, along with information about Cache and CacheStorage</a></li>
</ul>
